| Disk ARchive 2.8.3 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::sar Class Reference
Private

Sar class stands for Segmentation And Reassembly class. More...

`#include <sar.hpp>`

Inherits libdar::generic_file, libdar::contextual, and libdar::mem_ui.

## Public Member Functions
| sar (const std::shared_ptr< user_interaction > &dialog, const std::string &base_name, const std::string &extension, const std::shared_ptr< entrepot > &where, bool by_the_end, const infinint &x_min_digits, bool sequential_read, bool lax=false, const std::string &execute="")
| this constructor reads data from a set of slices
| sar (const std::shared_ptr< user_interaction > &dialog, gf_mode open_mode, const std::string &base_name, const std::string &extension, const infinint &file_size, const infinint &first_file_size, bool x_warn_overwrite, bool x_allow_overwrite, const infinint &pause, const std::shared_ptr< entrepot > &where, const label &internal_name, const label &data_name, bool force_permission, U_I permission, hash_algo x_hash, const infinint &x_min_digits, bool format_07_compatible, const std::string &execute="")
| this constructor creates a new set of slices
| sar (const sar &ref)=delete
| the copy constructor
| sar (sar &&ref) noexcept=delete
| move constructor
sar & | operator= (const sar &ref)=delete
| assignment operator
sar & | operator= (sar &&ref) noexcept=delete
| move operator
| ~sar ()
| destructor
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
const slice_layout & | get_slicing () const
bool | get_total_file_number (infinint &num) const
bool | get_last_file_size (infinint &num) const
void | disable_natural_destruction ()
void | enable_natural_destruction ()
virtual bool | is_an_old_start_end_archive () const override
| returns whether the archive is a old archive (format < 8)
const label & | get_internal_name_used () const
virtual const label & | get_data_name () const override
| obtain the data_name of the archive (label associated with the archive's data)
const std::shared_ptr< entrepot > & | get_entrepot () const
const infinint & | get_first_slice_header_size () const
| get the first slice header
const infinint & | get_non_first_slice_header_size () const
| get the non first slice header
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
Public Member Functions inherited from libdar::contextual
| contextual (const contextual &ref)=default
| contextual (contextual &&ref) noexcept=default
contextual & | operator= (const contextual &ref)=default
contextual & | operator= (contextual &&ref) noexcept=default
virtual void | set_info_status (const std::string &s)
| defines the new contextual value
virtual std::string | get_info_status () const
| get the current contextual value

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction object
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
void | change_ui (const std::shared_ptr< user_interaction > &new_dialog)
| change the user_interaction object
user_interaction & | get_ui () const
| get access to the user_interaction object
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
void | change_ui (const std::shared_ptr< user_interaction > &new_dialog)
| change the user_interaction object
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor
| mem_ui (const mem_ui &ref)=default
| the copy constructor
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor
| mem_ui (const mem_ui &ref)=default
| the copy constructor
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor

## Private Member Functions
bool | skip_forward (U_I x)
| skip forward in sar global contents
bool | skip_backward (U_I x)
| skip backward in sar global contents
void | close_file (bool terminal)
| close current openned file, adding (in write mode only) a terminal mark (last slice) or not
void | open_readonly (const std::string &fic, const infinint &num, bool bytheend)
void | open_writeonly (const std::string &fic, const infinint &num, bool bytheend)
void | open_file_init ()
| initialize some of_* fields
void | open_file (infinint num, bool bytheend)
| close current slice and open the slice 'num'
void | set_offset (infinint offset)
| skip to current slice relative offset
void | open_last_file (bool bytheend)
| open the last slice, ask the user, test, until last slice available
bool | is_current_eof_a_normal_end_of_slice () const
| return true if current reading position is at end of slice
infinint | bytes_still_to_read_in_slice () const
| returns the number of bytes expected before the end of slice
header | make_write_header (const infinint &num, char flag)
void | hook_execute (const infinint &num)

## Private Attributes
std::shared_ptr< entrepot > | entr
| where are stored slices
std::string | base
| archive base name
std::string | ext
| archive extension
std::string | hook
| command line to execute between slices
slice_layout | slicing
| slice layout
infinint | file_offset
| current reading/writing position in the current slice (relative to the whole slice file, including headers)
hash_algo | hash
| whether to build a hashing when creating slices, and if so, which algorithm to use
infinint | min_digits
| minimum number of digits the slices number is stored with in the filename
bool | natural_destruction
| whether to execute commands between slices on object destruction
infinint | of_current
| number of the open slice
infinint | size_of_current
| size of the current slice (used in reading mode only)
infinint | of_max_seen
| highest slice number seen so far
bool | of_last_file_known
| whether the T terminal slice has been met
infinint | of_last_file_num
| number of the last slice (if met)
infinint | of_last_file_size
| size of the last slice (if met)
label | of_internal_name
| internal name shared in all slice header
label | of_data_name
| internal name linked to data (transparent to dar_xform and used by isolated catalogue as reference)
bool | force_perm
| true if any future slice has its permission to be set explicitely
U_I | perm
| if force_perm is true, value to use for slice permission
fichier_global * | of_fd
| file object currently openned
char | of_flag
| flags of the open file
bool | initial
| do not launch hook command-line during sar initialization
bool | opt_warn_overwrite
| a warning must be issued before overwriting a slice
bool | opt_allow_overwrite
| is slice overwriting allowed
infinint | pause
| do we pause between slices
bool | lax
| whether to try to go further reading problems
infinint | to_read_ahead
| amount of data to read ahead for next slices
bool | seq_read
| whether sequential read has been requested
thread_cancellation | thr
| used to know whether to ask the user or assume negative answer to allow proper archive terminatio

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward , skip_backward , skip_forward }
enum | skippability { skip_backward , skip_forward , skip_backward , skip_forward }

## Detailed Description

Sar class stands for Segmentation And Reassembly class.

sar is used as a normal file but given some parameters at construction time the object will split the data in several files of given size (aka slices) sar uses a header to identify slices in a given set and tie slices of different sets At reading time sar transparently read data from the different slices.

Definition at line 55 of file sar.hpp.

## Constructor & Destructor Documentation

## ◆ sar() [1/2]

libdar::sar::sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | const std::string & | base_name,
|  | const std::string & | extension,
|  | const std::shared_ptr< entrepot > & | where,
|  | bool | by_the_end,
|  | const infinint & | x_min_digits,
|  | bool | sequential_read,
|  | bool | lax = false,
|  | const std::string & | execute = "" )

this constructor reads data from a set of slices

Parameters

  [in] | dialog | is for user interation (such a requesting a slice and pausing between slices)
  [in] | base_name | is the basename of all slices of the set (it will be added the ".<slice numer>.extension" to form a filename
  [in] | extension | is the extension of slice's filenames
  [in] | where | defines where to store or where are stored slices
  [in] | by_the_end | if true dar will try to open the slice set starting from the last slice else it will try starting from the first
  [in] | x_min_digits | is the minimum number of digits the slices number is stored with in the filename
  [in] | sequential_read | to be set to true for sequential reading
  [in] | lax | if set to true will try workaround problems that would otherwise lead the operation to fail
  [in] | execute | is the command to execute before trying to open each slice for reading

Note
  if by_the_end is set to true, the last slice must have extended slice header that contain informations about the first slice size (used starting archive format "08"), Else, the slice size is not possible to open as the offset of the data cannot be determined. If slice header is too old the sar class will fallback openning the first slice and directly get the first slice.

References lax.

Referenced by operator=(), operator=(), sar(), and sar().

## ◆ sar() [2/2]

libdar::sar::sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | gf_mode | open_mode,
|  | const std::string & | base_name,
|  | const std::string & | extension,
|  | const infinint & | file_size,
|  | const infinint & | first_file_size,
|  | bool | x_warn_overwrite,
|  | bool | x_allow_overwrite,
|  | const infinint & | pause,
|  | const std::shared_ptr< entrepot > & | where,
|  | const label & | internal_name,
|  | const label & | data_name,
|  | bool | force_permission,
|  | U_I | permission,
|  | hash_algo | x_hash,
|  | const infinint & | x_min_digits,
|  | bool | format_07_compatible,
|  | const std::string & | execute = "" )

this constructor creates a new set of slices

Parameters

  [in,out] | dialog | is used for user interaction
  [in] | open_mode | read_write or write_only is accepted only
  [in] | base_name | is the slice set base name
  [in] | extension | is the slices extension
  [in] | file_size | is the size of slices (in byte)
  [in] | first_file_size | is the size of the first slice (in byte) or set it to zero if it has to be equal to other slice's size
  [in] | x_warn_overwrite | if set to true, a warning will be issued before overwriting a slice
  [in] | x_allow_overwrite | if set to false, no slice overwritting will be allowed
  [in] | pause | if set to zero no pause will be done between slice creation. If set to 1 a pause between each slice will be done. If set to N a pause each N slice will be done. Pauses must be acknoledged by user for the process to continue
  [in] | where | defines where to store the slices
  [in] | internal_name | is a tag common to all slice of the archive
  [in] | data_name | is a tag that has to be associated with the data.
  [in] | force_permission | if true slice permission will be forced to the value given in the next argument
  [in] | permission | value to use to set permission of slices
  [in] | x_hash | defines whether a hash file has to be generated for each slice, and wich hash algorithm to use
  [in] | x_min_digits | is the minimum number of digits the slices number is stored with in the filename
  [in] | format_07_compatible | when set to true, creates a slice header in the archive format of version 7 instead of the highest version known
  [in] | execute | is the command to execute after each slice creation (once it is completed)

Note
  data_name should be equal to internal_name except when reslicing an archive as dar_xform does in which case internal_name is randomly, and data_name is kept from the source archive

References pause.

## Member Function Documentation

## ◆ disable_natural_destruction()

void libdar::sar::disable_natural_destruction | ( |  | ) |
| inline

Definition at line 164 of file sar.hpp.

## ◆ enable_natural_destruction()

void libdar::sar::enable_natural_destruction | ( |  | ) |
| inline

Definition at line 167 of file sar.hpp.

## ◆ get_data_name()

virtual const label & libdar::sar::get_data_name | ( |  | ) | const
| inline override virtual

obtain the data_name of the archive (label associated with the archive's data)

Note
  label are conserved with dar_xform and archive isolation, but are not with archive merging or archive creation (full or differential backup)

Implements libdar::contextual.

Definition at line 176 of file sar.hpp.

References of_data_name.

## ◆ get_entrepot()

const std::shared_ptr< entrepot > & libdar::sar::get_entrepot | ( |  | ) | const
| inline

Definition at line 178 of file sar.hpp.

## ◆ get_first_slice_header_size()

const infinint & libdar::sar::get_first_slice_header_size | ( |  | ) | const
| inline

get the first slice header

Definition at line 181 of file sar.hpp.

References slicing.

## ◆ get_internal_name_used()

const label & libdar::sar::get_internal_name_used | ( |  | ) | const
| inline

Definition at line 173 of file sar.hpp.

## ◆ get_last_file_size()

bool libdar::sar::get_last_file_size | ( | infinint & | num | ) | const
| inline

Definition at line 161 of file sar.hpp.

## ◆ get_non_first_slice_header_size()

const infinint & libdar::sar::get_non_first_slice_header_size | ( |  | ) | const
| inline

get the non first slice header

Definition at line 184 of file sar.hpp.

References slicing.

## ◆ get_position()

virtual infinint libdar::sar::get_position | ( |  | ) | const
| override virtual

get the current read/write position

Implements libdar::generic_file.

References slicing.

## ◆ get_slicing()

const slice_layout & libdar::sar::get_slicing | ( |  | ) | const
| inline

Definition at line 159 of file sar.hpp.

## ◆ get_total_file_number()

bool libdar::sar::get_total_file_number | ( | infinint & | num | ) | const
| inline

Definition at line 160 of file sar.hpp.

## ◆ inherited_flush_read()

virtual void libdar::sar::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 192 of file sar.hpp.

## ◆ inherited_read()

virtual U_I libdar::sar::inherited_read | ( | char * | a,
|  | U_I | size )
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::sar::inherited_read_ahead | ( | const infinint & | amount | ) |
| override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

## ◆ inherited_sync_write()

virtual void libdar::sar::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 191 of file sar.hpp.

## ◆ inherited_terminate()

virtual void libdar::sar::inherited_terminate | ( |  | ) |
| override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_truncate()

virtual void libdar::sar::inherited_truncate | ( | const infinint & | pos | ) |
| override protected virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

## ◆ inherited_write()

virtual void libdar::sar::inherited_write | ( | const char * | a,
|  | U_I | size )
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ is_an_old_start_end_archive()

virtual bool libdar::sar::is_an_old_start_end_archive | ( |  | ) | const
| inline override virtual

returns whether the archive is a old archive (format < 8)

Implements libdar::contextual.

Definition at line 170 of file sar.hpp.

References slicing.

## ◆ open_readonly()

void libdar::sar::open_readonly | ( | const std::string & | fic,
|  | const infinint & | num,
|  | bool | bytheend )
| private

Parameters

  fic | open file of name "fic" for read only
  num | "num" is the slice number
  bytheend | whether to position the read cursor at the beginning or the end of the file

## ◆ open_writeonly()

void libdar::sar::open_writeonly | ( | const std::string & | fic,
|  | const infinint & | num,
|  | bool | bytheend )
| private

Parameters

  fic | open file of name "filename" for write only
  num | "num" is the slice number
  bytheend | whether to overwrite or to append data to be written to the file

## ◆ skip()

virtual bool libdar::sar::skip | ( | const infinint & | pos | ) |
| override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_relative()

virtual bool libdar::sar::skip_relative | ( | S_I | x | ) |
| override virtual

skip relatively to the current position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::sar::skip_to_eof | ( |  | ) |
| override virtual

skip to the end of file

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::sar::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

## ◆ truncatable()

virtual bool libdar::sar::truncatable | ( | const infinint & | pos | ) | const
| override virtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

## Member Data Documentation

## ◆ base

std::string libdar::sar::base
| private

archive base name

Definition at line 197 of file sar.hpp.

## ◆ entr

std::shared_ptr<entrepot> libdar::sar::entr
| private

where are stored slices

Definition at line 196 of file sar.hpp.

## ◆ ext

std::string libdar::sar::ext
| private

archive extension

Definition at line 198 of file sar.hpp.

## ◆ file_offset

infinint libdar::sar::file_offset
| private

current reading/writing position in the current slice (relative to the whole slice file, including headers)

Definition at line 201 of file sar.hpp.

## ◆ force_perm

bool libdar::sar::force_perm
| private

true if any future slice has its permission to be set explicitely

Definition at line 215 of file sar.hpp.

## ◆ hash

hash_algo libdar::sar::hash
| private

whether to build a hashing when creating slices, and if so, which algorithm to use

Definition at line 202 of file sar.hpp.

## ◆ hook

std::string libdar::sar::hook
| private

command line to execute between slices

Definition at line 199 of file sar.hpp.

## ◆ initial

bool libdar::sar::initial
| private

do not launch hook command-line during sar initialization

Definition at line 219 of file sar.hpp.

## ◆ lax

bool libdar::sar::lax
| private

whether to try to go further reading problems

Definition at line 225 of file sar.hpp.

Referenced by sar().

## ◆ min_digits

infinint libdar::sar::min_digits
| private

minimum number of digits the slices number is stored with in the filename

Definition at line 203 of file sar.hpp.

## ◆ natural_destruction

bool libdar::sar::natural_destruction
| private

whether to execute commands between slices on object destruction

Definition at line 204 of file sar.hpp.

## ◆ of_current

infinint libdar::sar::of_current
| private

number of the open slice

Definition at line 207 of file sar.hpp.

## ◆ of_data_name

label libdar::sar::of_data_name
| private

internal name linked to data (transparent to dar_xform and used by isolated catalogue as reference)

Definition at line 214 of file sar.hpp.

Referenced by get_data_name().

## ◆ of_fd

fichier_global* libdar::sar::of_fd
| private

file object currently openned

Definition at line 217 of file sar.hpp.

## ◆ of_flag

char libdar::sar::of_flag
| private

flags of the open file

Definition at line 218 of file sar.hpp.

## ◆ of_internal_name

label libdar::sar::of_internal_name
| private

internal name shared in all slice header

Definition at line 213 of file sar.hpp.

## ◆ of_last_file_known

bool libdar::sar::of_last_file_known
| private

whether the T terminal slice has been met

Definition at line 210 of file sar.hpp.

## ◆ of_last_file_num

infinint libdar::sar::of_last_file_num
| private

number of the last slice (if met)

Definition at line 211 of file sar.hpp.

## ◆ of_last_file_size

infinint libdar::sar::of_last_file_size
| private

size of the last slice (if met)

Definition at line 212 of file sar.hpp.

## ◆ of_max_seen

infinint libdar::sar::of_max_seen
| private

highest slice number seen so far

Definition at line 209 of file sar.hpp.

## ◆ opt_allow_overwrite

bool libdar::sar::opt_allow_overwrite
| private

is slice overwriting allowed

Definition at line 222 of file sar.hpp.

## ◆ opt_warn_overwrite

bool libdar::sar::opt_warn_overwrite
| private

a warning must be issued before overwriting a slice

Definition at line 221 of file sar.hpp.

## ◆ pause

infinint libdar::sar::pause
| private

do we pause between slices

Definition at line 224 of file sar.hpp.

Referenced by sar().

## ◆ perm

U_I libdar::sar::perm
| private

if force_perm is true, value to use for slice permission

Definition at line 216 of file sar.hpp.

## ◆ seq_read

bool libdar::sar::seq_read
| private

whether sequential read has been requested

Definition at line 227 of file sar.hpp.

## ◆ size_of_current

infinint libdar::sar::size_of_current
| private

size of the current slice (used in reading mode only)

Definition at line 208 of file sar.hpp.

## ◆ slicing

slice_layout libdar::sar::slicing
| private

slice layout

Definition at line 200 of file sar.hpp.

Referenced by get_first_slice_header_size(), get_non_first_slice_header_size(), get_position(), and is_an_old_start_end_archive().

## ◆ thr

thread_cancellation libdar::sar::thr
| private

used to know whether to ask the user or assume negative answer to allow proper archive terminatio

Definition at line 228 of file sar.hpp.

## ◆ to_read_ahead

infinint libdar::sar::to_read_ahead
| private

amount of data to read ahead for next slices

Definition at line 226 of file sar.hpp.

The documentation for this class was generated from the following file:

- sar.hpp